package o1.subprograms

// WRITE YOUR OWN FUNCTIONS BELOW THESE IMPORT COMMANDS:
import o1.*
import scala.math.*
















// Here is a buggy piece of code for you to fix in one of Chapter 1.7’s assignments.
def onTwoInstruments(melody: String, first: Int, second: Int, lengthOfPause: Int) =
  val melodyUsingFirst  = "[" + first  + "]" + melody
  val melodyUsingSecond = "[" + second + "]" + melody
  val pause = " " * lengthOfPause
  val playedTwice = melodyUsingFirst + pause + melodyUsingSecond






// HERE ARE SOME EXAMPLE FUNCTIONS WHOSE IMPLEMENTATIONS WE EXAMINE IN CHAPTERS 1.7 AND 1.8.
// PLEASE SEE THE CHAPTER TEXTS FOR DETAILED EXPLANATIONS.

def average(first: Double, second: Double) = (first + second) / 2

def yell(phrase: String) = phrase + "!"

def careerAdvicePlease(addendum: String) =
  println("Oppenheimer built the bomb, but now he's dead. (Dead!)")
  println("Einstein was very, very smart, but not enough not to be dead. (Dead!)")
  println("So don't go into science; you'll end up dead.")
  println("Don't go into science; you'll end up dead.")
  println(addendum)


def redBall(size: Int) = circle(size, Red)


def distance(x1: Double, y1: Double, x2: Double, y2: Double) = hypot(x2 - x1, y2 - y1)

def greatestDistance(x1: Double, y1: Double, x2: Double, y2: Double, x3: Double, y3: Double) =
  val first  = distance(x1, y1, x2, y2)
  val second = distance(x1, y1, x3, y3)
  val third  = distance(x2, y2, x3, y3)
  max(max(first, second), third)


def incomeTax(income: Double, thresholdIncome: Double, baseRate: Double, additionalRate: Double) =
  val baseTax = min(thresholdIncome, income)
  val additionalTax = max(income - thresholdIncome, 0)
  baseTax * baseRate + additionalTax * additionalRate


def experiment1(number: Int) =
  println("The number is: " + number)

def experiment2(numbers: Buffer[Int]) =
  numbers(0) = 100

def experiment3(number: Int) =
  println("The number is: " + number)
  number + 1

def experiment4(word: String) =
  var number = 1
  println(word + ": " + number)
  number = number + 1
  println(word + ": " + number)
  number = number + 1
  println(word + ": " + number)
  number

def experiment5(initial: Int) =
  var number = initial
  number = number + 1
  number = number + 1
  number = number + 1
  number

def test1(text: String) =
  println(text)
  "always the same string"

def test2(text: String) =
  println(text)
  val response = test1(yell(text))
  test1(text)
  println("we got:")
  println(response)



// HERE ARE SOME FUNCTIONS WHICH WE MAKE USE OF IN CHAPTER 1.6.
// You do NOT need to understand their internal workings at that stage.
// The program code below has not been written in a beginner-friendly style.


def removeNegatives(numbers: Buffer[Int]): Unit =
  numbers --= numbers.filter( _ < 0 )


private class Movie(val name: String, val year: Int, val rank: Int, val rating: Double, val directors: Seq[String]):
  def isMadeBetween(startYear: Int, endYear: Int) =
    this.year >= startYear && this.year <= endYear

def imdbMovie(rank: Int) = movies.sortBy( _.rank ).apply(rank - 1).name

def imdbBestBetween(startYear: Int, endYear: Int) =
  movies.filter( _.isMadeBetween(startYear, endYear) ).sortBy( _.rank ).head.name

def imdbBestDirectors(minMovieCount: Int) =
  import o1.util.nice.collection.*
  val dirCountPairs = movies.flatMap( _.directors ).frequencies
  val relevantPairs = dirCountPairs.filter( (dir, count) => count >= minMovieCount )
  val dirRanking = relevantPairs.toList.sortBy( (dir, count) => -count )
  dirRanking.map( (dir, count) => s"$dir ($count)" ).mkString(", ")

private lazy val movies =
  val Subdir   = "top_movies"
  val FileName = "omdb_movies_2015.txt"
  val rawLines = o1.util.readFileLines(s"$Subdir/$FileName").getOrElse( throw Exception(s"Could not read the file $FileName, which is expected to be under $Subdir.") )
  val linesAsTokens = rawLines.map( _.split(";") )
  linesAsTokens.map( tokens => Movie(tokens(0), tokens(1).toInt, tokens(2).toInt, tokens(3).toDouble, tokens(4).split(",").toSeq) )


def editDistance(text1: String, text2: String) = o1.util.editDistance(text1, text2, 12)


def canon(song: String, instruments: Iterable[Int], delay: Int) =
  import o1.sound.midi.*
  import o1.util.nice.number.*
  import o1.util.nice.regex.*

  val (melody, tempo) = song match
    case r"(.*?)$melody(?:/([\d]+)$tempoOrNull)?" => (melody, Option(tempoOrNull))

  def initialWait(instrumentNr: Int) = " " * (instrumentNr * delay atLeast 0 atMost melody.length)

  val inCounterpoint = for (instrument, instrumentNr) <- instruments.take(MaxVoices).zipWithIndex
                       yield s"${initialWait(instrumentNr)}[$instrument]$melody"

  inCounterpoint.mkString("&") + tempo.map( "/" + _ ).getOrElse("")
end canon


def censor(text: String, naughtyWords: Iterable[String]) =
  def beep(length: Int) = "[B" + "E" * max(0, length - 2) + "P]"
  def beepOutWord(text: String, word: String) = text.replaceAll(word, beep(word.length))
  naughtyWords.foldLeft(text)(beepOutWord)


def playDoodads(player: String) =
  o1.gui.O1SwingDefaults()
  import o1.gui.Dialog.*
  display(s"Welcome to the game of DOODADS, $player!\nIn the beginning, there are twelve Doodads.\n" +
          "We will take turns choosing to pick up either 1 or 2 Doodads.\nThe one who picks up the last Doodad wins.", Centered)
  LazyList.iterate(12)(playOneRound).takeWhile(gameContinues).force
  display(s"I'm afraid you lost, $player. Sorry about that.\n", Centered)

  def playOneRound(doodadsLeft: Int) =
    requestPick(doodadsLeft).map( humanPick => computerPlays(doodadsLeft - humanPick) ).getOrElse(0)

  def isValidPick(pick: Int) = pick == 1 || pick == 2

  def requestPick(doodadsLeft: Int) =
    requestInt(s"There are $doodadsLeft Doodads remaining. How many will you pick up?", isValidPick, "Please take either 1 or 2.", Centered)

  def computerPlays(doodadsLeft: Int) =
    val computerPick = bestChoice(doodadsLeft)
    display(s"I'll take $computerPick Doodad${(if computerPick == 1 then "" else "s")}.", Centered)
    doodadsLeft - computerPick

  def gameContinues(doodadsLeft: Int) = doodadsLeft > 0
  def bestChoice(doodadsLeft: Int) = doodadsLeft % 3

end playDoodads


def showInfo(word: String) =
  println("The word: " + word + " was received as a parameter.")
  word.length


def volumeOfSphere(radius: Double) = 4 * Pi * pow(radius, 3) / 3

